org.apache.solr.client.solrj.impl

## Class CloudSolrClient.Builder

- java.lang.Object
- - org.apache.solr.client.solrj.impl.CloudSolrClient.Builder

Enclosing class:
  CloudSolrClient

    public static class CloudSolrClient.Builder
    extends Object

Constructs `CloudSolrClient` instances from provided configuration.

### Constructor Summary

Constructors
Constructor and Description
`Builder()`

### Method Summary

All Methods Instance Methods Concrete Methods
`CloudSolrClient` `build()` Create a `CloudSolrClient` based on the provided configuration.
`CloudSolrClient.Builder` `sendUpdatesOnlyToShardLeaders()` Tells `CloudSolrClient.Builder` that created clients should send updats only to shard leaders.
`CloudSolrClient.Builder` `sendUpdatesToAllReplicasInShard()` Tells `CloudSolrClient.Builder` that created clients should send updates to all replicas for a shard.
`CloudSolrClient.Builder` `withHttpClient(org.apache.http.client.HttpClient httpClient)` Provides a `HttpClient` for the builder to use when creating clients.
`CloudSolrClient.Builder` `withLBHttpSolrClient(LBHttpSolrClient loadBalancedSolrClient)` Provides a `LBHttpSolrClient` for the builder to use when creating clients.
`CloudSolrClient.Builder` `withZkChroot(String zkChroot)` Provides a ZooKeeper chroot for the builder to use when creating clients.
`CloudSolrClient.Builder` `withZkHost(Collection<String> zkHosts)` Provide a series of ZooKeeper client endpoints for the builder to use when creating clients.
`CloudSolrClient.Builder` `withZkHost(String zkHost)` Provide a ZooKeeper client endpoint to be used when configuring `CloudSolrClient` instances.

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Constructor Detail

#### Builder

    public Builder()

### Method Detail

#### withZkHost

    public CloudSolrClient.Builder withZkHost(String zkHost)

Provide a ZooKeeper client endpoint to be used when configuring `CloudSolrClient` instances. Method may be called multiple times. All provided values will be used.

Parameters:
  `zkHost` - The client endpoint of the ZooKeeper quorum containing the cloud state.

#### withHttpClient

    public CloudSolrClient.Builder withHttpClient(org.apache.http.client.HttpClient httpClient)

Provides a `HttpClient` for the builder to use when creating clients.

#### withZkHost

    public CloudSolrClient.Builder withZkHost(Collection<String> zkHosts)

Provide a series of ZooKeeper client endpoints for the builder to use when creating clients. Method may be called multiple times. All provided values will be used.

Parameters:
  `zkHosts` - A Java Collection (List, Set, etc) of HOST:PORT strings, one for each host in the ZooKeeper ensemble. Note that with certain Collection types like HashSet, the order of hosts in the final connect string may not be in the same order you added them.

#### withZkChroot

    public CloudSolrClient.Builder withZkChroot(String zkChroot)

Provides a ZooKeeper chroot for the builder to use when creating clients.

#### withLBHttpSolrClient

    public CloudSolrClient.Builder withLBHttpSolrClient(LBHttpSolrClient loadBalancedSolrClient)

Provides a `LBHttpSolrClient` for the builder to use when creating clients.

#### sendUpdatesOnlyToShardLeaders

    public CloudSolrClient.Builder sendUpdatesOnlyToShardLeaders()

Tells `CloudSolrClient.Builder` that created clients should send updats only to shard leaders.

#### sendUpdatesToAllReplicasInShard

    public CloudSolrClient.Builder sendUpdatesToAllReplicasInShard()

Tells `CloudSolrClient.Builder` that created clients should send updates to all replicas for a shard.

#### build

    public CloudSolrClient build()

Create a `CloudSolrClient` based on the provided configuration.